import 'package:flutter/material.dart';
import 'package:softcorp_flutter_core/hoverBuilder/hoverBuilder.dart';

import '../../constants.dart';

class OnHover extends StatefulWidget {
  final Widget child;
  final Function onTap;
  final Color shadowColor;

  const OnHover(
      {Key? key,
      required this.child,
      required this.onTap,
      required this.shadowColor})
      : super(key: key);

  @override
  State<StatefulWidget> createState() {
    return _OnHoverState();
  }
}

class _OnHoverState extends State<OnHover> {
  Color? shadowColor = Colors.black;
  double? elevation = null;

  @override
  void setState(VoidCallback fn) {
    shadowColor = widget.shadowColor;
    super.setState(fn);
  }

  @override
  Widget build(BuildContext context) {
    return RaiseOnHover(builder: (isHovered) {
      return MouseRegion(
        onEnter: (_) {
          setState(() {
            shadowColor = softcorpPrimaryColor;
            elevation = 12.0;
          });
        },
        onExit: (_) {
          setState(() {
            shadowColor = widget.shadowColor;
            elevation = null;
          });
        },
        cursor: SystemMouseCursors.click,
        child: GestureDetector(
          onTap: () => widget.onTap(),
          child: widget.child,
        ),
      );
    });
  }
}
