import 'package:flutter/material.dart';
import 'package:softcorp_flutter_core/default_card/components/onHover.dart';

import '../constants.dart';

class DefaultCard extends StatelessWidget {
  final Color? backgroundColor;
  final Widget child;
  final Color? shadowColor;
  final double? elevation;
  final Function? onTap;

  const DefaultCard(
      {Key? key, this.backgroundColor, required this.child, this.shadowColor, this.elevation, this.onTap})
      : super(key: key);

  @override
  Widget build(BuildContext context) {
    Widget defaultCard = Card(
      elevation: elevation ?? defaultElevation,
      color: backgroundColor,
      semanticContainer: true,
      clipBehavior: Clip.antiAliasWithSaveLayer,
      shadowColor: shadowColor,
      shape: RoundedRectangleBorder(
        borderRadius: BorderRadius.circular(defaultCornerRadius),
        side: elevation == 0 ? const BorderSide(
          color: borderColor,
          width: 1.2,
        ) : BorderSide.none,
      ),
      margin: const EdgeInsets.all(10),
      child: child,
    );
    if (onTap != null) {
      return OnHover(child: defaultCard,
          onTap: onTap!,
          shadowColor: shadowColor ?? Colors.black);
    }
    return defaultCard;
  }
}
